/*
 * @Author: zx 
 * @Date: 2020-06-30 17:40:43 
 * @Last Modified by: zx
 * @Last Modified time: 2020-07-02 18:44:20
 */

import 'package:cached_network_image/cached_network_image.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/gestures.dart';
import 'package:flutter/material.dart';
import 'package:gm_flutter/ClueModel/page/PlanCompareDetail/PlanCompareDetailModel.dart';
import 'package:gm_flutter/ClueModel/server/entity/PlanCompareDetail.dart';
import 'package:gm_flutter/ClueModel/view/FiveStarView.dart';
import 'package:gm_flutter/commonModel/base/BaseComponent.dart';
import 'package:gm_flutter/commonModel/base/BaseState.dart';
import 'package:gm_flutter/commonModel/bean/Pair.dart';

class PlanCompareDetailPage extends StatefulWidget {
  @override
  State<StatefulWidget> createState() => PlanCompareDetailPageState();
}

class PlanCompareDetailPageState extends BaseState<PlanCompareDetailPage> {
  PlanCompareDetailModel _model = new PlanCompareDetailModel();
  double screenWidth;
  List<Widget> viewList = new List();
  @override
  void initState() {
    super.initState();
    _model.init([1, 2]);
  }

  @override
  void dispose() {
    _model.dispose();
    super.dispose();
  }

  @override
  Widget buildItem(BuildContext context) {
    screenWidth = MediaQuery.of(context).size.width;
    return Scaffold(
        appBar: baseAppBar(
            title: "对比详情",
            centerTitle: true,
            backClick: () {
              Navigator.pop(context);
            }),
        body: Container(
          child:
              // head(),

              // planPopularityView()
              // planNormalEffectiveAttrsView()
              // setupHome([], []),
              reloadPage(),
        ));
  }

  Widget reloadPage() {
    return StreamBuilder(
      stream: _model.detailLive.stream,
      initialData: _model.detailLive.data ?? Pair(LOADING, null),
      builder: (c, data) {
        if (data.data.first == FAIL) {
          return errorItem(MediaQuery.of(context).size.width,
              MediaQuery.of(context).size.height, () {
            _model.init([1, 2]);
          });
        }
        if (data.data.first == LOADING || _model.detailLive == null) {
          return loadingItem();
        }
        if (data.data.second.length == 0) {
          return emptyItem(MediaQuery.of(context).size.width,
              MediaQuery.of(context).size.height);
        }
        return setupHome([], data.data.second);
      },
    );
  }

  Widget setupHome(List<PlansInfo> plansInfo, List<Groups> groups) {
    return Column(
      children: <Widget>[
        head(),
        Expanded(
          child: Container(
              margin: EdgeInsets.fromLTRB(15, 0, 15, 0),
              color: Colors.green,
              child: ListView.builder(
                itemBuilder: (BuildContext context, int index) {
                  Groups group = groups[index];
                  switch (group.groupType) {
                    case 'hot':
                      // return planPopularityView(plansInfo);
                      // return planNormalEffectiveAttrsView(group);
                      return Container(
                        height: 100,
                        color: Colors.red,
                      );
                      break;
                    case 'normal_attrs':
                      return Container(
                        // height: double.maxFinite,
                        color: Colors.yellow,
                        child: planNormalEffectiveAttrsView(group),
                      );
                      // return planNormalEffectiveAttrsView(group);
                      break;
                    case 'effective_attrs':
                      return Container(
                        // height: double.maxFinite,
                        color: Colors.blue,
                        child: planNormalEffectiveAttrsView(group),
                      );
                      // return planNormalEffectiveAttrsView(group);
                      break;
                    default:
                      return planNormalEffectiveAttrsView(group);
                  }
                },
                itemCount: groups.length,
              )),
        )
      ],
    );
  }

  Widget head() {
    PlansInfo plan;
    return Container(
      // key: keyTop,
      color: Colors.yellow,
      width: screenWidth,
      height: 105,
      alignment: Alignment.topLeft,
      margin: EdgeInsets.fromLTRB(9.5, 0, 9.5, 0),
      child: Row(children: <Widget>[
        // 根据 flex系数，分配剩余空间
        Expanded(flex: 1, child: headItem(plan)),
        Expanded(flex: 1, child: headItem(plan))
      ]),
    );
  }

  Widget headItem(PlansInfo plan) {
    return Container(
        child: Stack(children: <Widget>[
      Positioned(
          child: Container(
        decoration: BoxDecoration(
          borderRadius: BorderRadius.circular(15),
        ),
        alignment: Alignment.center,
        margin: EdgeInsets.fromLTRB(5.5, 15, 5.5, 15),
        child: Image.asset('assets/plan_compare_detail_info_bg.png',
            fit: BoxFit.cover),
      )),
      Positioned(
        left: 17.5,
        top: 31,
        child: baseText('11111', 15, Color(0xff333333), bold: true),
      ),
      Positioned(
        left: 17.5,
        bottom: 31,
        child: baseText('￥￥￥￥￥￥￥￥￥￥', 14, Colors.red, bold: true),
      ),
    ]));
  }

  Widget titleView(String title) {
    return Container(
      height: 81,
      width: screenWidth,
      color: Colors.cyan,
      margin: EdgeInsets.fromLTRB(0, 30, 0, 13),
      alignment: Alignment.topCenter,
      child: Container(
        child: baseText(title, 21, Colors.black, bold: true),
      ),
    );
  }

  Widget planPopularityView(List<PlansInfo> planInfo) {
    return Container(
      color: Colors.green,
      height: 265,
      child: Container(
          child: Column(children: <Widget>[
        titleView('111111'),
        Row(children: <Widget>[
          Expanded(flex: 1, child: planPopularityLeftItem(planInfo[0])),
          Expanded(flex: 1, child: planPopularityRightItem(planInfo[1]))
        ])
      ])),
    );
  }

  Widget planPopularityLeftItem(PlansInfo plan) {
    return Container(
        color: Colors.red,
        //  height: 80,
        child: Expanded(
            child: Stack(children: <Widget>[
          Positioned(
              right: 20,
              top: 12,
              child: baseText('99%', 21, Color(0xffF25874), bold: true)),
          Positioned(
            right: 20,
            top: 33,
            // bottom: 12,
            child: baseText('好评率', 12, Color(0xff666666), bold: false),
          ),
          Positioned(
            right: 20,
            top: 55,
            // bottom: 12,
            child: FiveStarView(3, 5),
          ),
          Positioned(
            right: 20,
            top: 98,
            bottom: 12,
            child: baseText('13679个', 21, Color(0xffF25874), bold: true),
          ),
          Positioned(
            right: 20,
            top: 112,
            bottom: 12,
            child: baseText('销量', 12, Color(0xff666666), bold: false),
          ),
          Positioned(
            right: 20,
            top: 132,
            bottom: 12,
            child: baseText('', 12, Color(0xff666666), bold: false),
          ),
        ])));
  }

  Widget planPopularityRightItem(PlansInfo plan) {
    return Container(
        color: Colors.red,
        //  height: 80,
        child: Expanded(
            child: Stack(children: <Widget>[
          Positioned(
              left: 20,
              top: 12,
              child: baseText('99%', 21, Color(0xffF25874), bold: true)),
          Positioned(
            left: 20,
            top: 33,
            // bottom: 12,
            child: baseText('好评率', 12, Color(0xff666666), bold: false),
          ),
          Positioned(
            left: 20,
            top: 55,
            // bottom: 12,
            child: FiveStarView(3, 5),
          ),
          Positioned(
            left: 20,
            top: 98,
            bottom: 12,
            child: baseText('13679个', 21, Color(0xffF25874), bold: true),
          ),
          Positioned(
            left: 20,
            top: 112,
            bottom: 12,
            child: baseText('销量', 12, Color(0xff666666), bold: false),
          ),
          Positioned(
            left: 20,
            top: 132,
            bottom: 12,
            child: baseText('', 12, Color(0xff666666), bold: false),
          ),
        ])));
  }

  Widget planNormalEffectiveAttrsView(Groups groups) {
    List<Widget> list = new List();
    list.add(titleView(groups.groupName));
    groups.plans.forEach((element) {
      list.add(planBaseAttrsView(element));
    });
    return Container(
        color: Colors.green,
        child:
            Column(mainAxisAlignment: MainAxisAlignment.center, children: list

                // <Widget>[
                //   Expanded(
                //       child: Stack(children: <Widget>[
                //     ,
                //     Expanded(
                //         child: Container(
                //             margin: EdgeInsets.fromLTRB(0, 68, 0, 0),
                //             child:
                //             ListView.builder(
                //               shrinkWrap: true,
                //               physics: NeverScrollableScrollPhysics(),
                //               itemBuilder: (c, index) {
                //                 return planBaseAttrsView(groups.plans);
                //               },
                //               itemCount: 5,
                //             )))
                //   ]))
                ));
  }

  Widget planBaseAttrsView(Plans plans) {
    return Container(
        color: Colors.red,
        height: 80,
        child: Row(children: <Widget>[
          Expanded(flex: 1, child: planBaseAttrsLeftView(plans)),
          Expanded(flex: 1, child: planBaseAttrsRightView(plans))
        ]));
  }

  Widget planBaseAttrsLeftView(Plans plan) {
    return Container(
        color: Colors.red,
        height: 80,
        child: Stack(children: <Widget>[
          Positioned(
              right: 20,
              top: 12,
              child: baseText(plan.attrs[0].attrValue, 14, Color(0xff3FB5AF),
                  bold: true)),
          Positioned(
            right: 20,
            // top: 12,
            bottom: 12,
            child: baseText(plan.attrs[0].attrName, 12, Color(0xff666666),
                bold: false),
          ),
        ]));
  }

  Widget planBaseAttrsRightView(Plans plan) {
    return Container(
        color: Colors.red,
        height: 80,
        child: Stack(children: <Widget>[
          Positioned(
              left: 20,
              top: 12,
              child: baseText(plan.attrs[0].attrValue, 14, Color(0xffF25874),
                  bold: true)),
          Positioned(
            left: 20,
            // top: 12,
            bottom: 12,
            child: baseText(plan.attrs[0].attrName, 12, Color(0xff666666),
                bold: false),
          ),
        ]));
  }
}
